'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _getError = require('./get-error');

var _getError2 = _interopRequireDefault(_getError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//Handles injecting props into the input fields (any component with a name prop)
exports.default = function (child, propValues, children, errors, component) {
  var _child$props = child.props,
      name = _child$props.name,
      _onKeyUp = _child$props.onKeyUp,
      onEnter = _child$props.onEnter;


  return _react2.default.cloneElement(child, {
    children: children,
    onChange: function onChange(e) {
      return component.validateOnBlurOrChange(name, function () {
        return component.onChange(e);
      });
    },
    onBlur: function onBlur() {
      return component.validateOnBlurOrChange(name);
    },
    error: (0, _getError2.default)(errors, component.props.errors, name),
    value: component.state.values[name] || component.state.values[name] === false ? component.state.values[name] : propValues[name] || propValues[name] === false ? propValues[name] : '',
    onKeyUp: function onKeyUp(e) {
      if (_onKeyUp) _onKeyUp(e);
      if (e.keyCode !== 13) return;
      if (onEnter) component.validate(onEnter);
    }
  });
};